//============================================================================
// Name        : Spongia.cpp
// Author      : BurningMarek
// Version     :
// Copyright   : Created by team Burning Marek (2009)
// Description : Hello World in C++, Ansi-style
//============================================================================

#define window_width 800
#define window_height 600

#include "libs.h"

void GL_Setup(int width, int height)
{
	glEnable( GL_TEXTURE_2D );
	SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 2 ) ;
	SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 32 );
	glViewport( 0, 0, width, height );
	glMatrixMode( GL_PROJECTION );
	gluPerspective( 45, (float)width/height, 0.9, 10000 );
	glEnable( GL_DEPTH );
	glMatrixMode( GL_MODELVIEW );

	//glEnable(GL_FOG);
	//glFogf(GL_FOG_MODE,GL_LINEAR);
	//glFogf(GL_FOG_COLOR,);
	//glFogf(GL_FOG_DENSITY,0);
	//glFogf(GL_FOG_START,7000);
	//glFogf(GL_FOG_END,8000);

	glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
}

int main(int argc, char *argv[])
{
    // initialize SDL video
    if ( SDL_Init( SDL_INIT_EVERYTHING ) < 0 )
    {
        printf( "Unable to init SDL: %s\n", SDL_GetError() );
        return 1;
    }

    if ( TTF_Init() < 0 )
    {
        printf( "Unable to init TTF: %s\n", SDL_GetError() );
        return 1;
    }

    // make sure SDL cleans up before exit
    atexit(SDL_Quit);
    atexit(TTF_Quit);
    srand(time(0));

    const SDL_VideoInfo* info = SDL_GetVideoInfo();
    int vidFlags =SDL_SRCALPHA | SDL_DOUBLEBUF | SDL_OPENGL | SDL_FULLSCREEN;
    if (info->hw_available) {printf("hws\n"); vidFlags |= SDL_HWSURFACE;}
    else {printf("sws\n"); vidFlags |= SDL_SWSURFACE;}
    int bpp = info->vfmt->BitsPerPixel;

    // create a new window
    SDL_Surface* screen = SDL_SetVideoMode(window_width, window_height, bpp, vidFlags);
    if ( !screen )
    {
        printf("Unable to set video: %s\n", SDL_GetError());
        return 1;
    }
    GL_Setup(window_width, window_height);
    // program main loop

    Menu *menu = new Menu();
    delete menu;

    // all is well ;)
    printf("Exited cleanly\n");
    return 0;
}
