/*
 * font.cpp
 *
 *  Created on: 11.10.2009
 *      Author: Jan
 */

#include "libs.h"

Font::Font(SDL_Surface* screen)
{
    _screen = screen;
    _ha = 0;
    _va = 0;
}

Font::Font(SDL_Surface* screen, const char* path, int size)
{
    _screen = screen;
    _font = TTF_OpenFont(path, size);
    _col.r = 0; _col.g = 0; _col.b = 0;
    _ha = 0;
    _va = 0;
}

Font::~Font()
{
    TTF_CloseFont(_font);
}

void Font::draw_text(const char* text, int x, int y)
{
    SDL_Surface* btext = TTF_RenderText_Solid(_font, text, _col);
    int w,h;
    TTF_SizeText(_font, text, &w, &h);
    SDL_Rect rect;
    rect.x = x-(w*_ha)/2;
    rect.y = y-(h*_va)/2;
    SDL_BlitSurface(btext, 0, _screen, &rect);
}

void Font::set_color(SDL_Color color)
{
    _col.r = color.r; _col.g = color.g; _col.b = color.b;
}

void Font::set_halign(int align)
{
    _ha = align;
}

void Font::set_valign(int align)
{
    _va = align;
}

SDL_Color sdl_rgb(int r, int g, int b)
{
        SDL_Color color;
        color.r = r;
        color.g = g;
        color.b = b;
        return color;
}

