/*
 * game.cpp
 *
 *  Created on: 17.10.2009
 *      Author: Jan
 */

#include "libs.h"

#define TIME_DELAY 40

Game::Game(Menu * menu)
{
    printf("game created \n");
	//_screen = menu->_screen;
    playerCount = menu->playerCount;
    textureG = SDL_LoadBMP("Data/Textures/sand.bmp");
    
    printf("images loaded\n");

    camx = camy = camtx =  camty = camtz = 0.0;
    camz = 500;
    camhs = 0; camvs = 0;
	camtz = 10.0;

    wminx = wminy = -1000;
    wmaxx = wmaxy = 1000;
    //printf("camhsp: %f \n",camhsp);
    //for (int i = 1; i<8; i++)
    //{
    //	int array[100000];
    //}

    cdd = czd = 0;
    cxd = cyd = 0;

    race_start();

    Mix_Chunk *sound;

    sound = sdl_sound_play("Data/Music/game.wav", 10000);

    bool done = false;
    unsigned int tTime;
    while (!done)
    {
        tTime = SDL_GetTicks();
        step(done);
        draw();
        tTime = SDL_GetTicks() - tTime;
        if ((tTime>0)&&(tTime<TIME_DELAY))
            SDL_Delay(TIME_DELAY-tTime);
        printf("%i \n",tTime);
        time -= TIME_DELAY/1000.0;
    }

    sdl_sound_stop(sound);


}

Game::~Game()
{
	for(int i = 0; i<playerCount; i++)
    {
        inh = i;
        delete player[i];
    }
	delete ball;
}

void Game::step(bool &done)
{
    SDL_Event event;
    while (SDL_PollEvent(&event))
    {
        switch (event.type)
        {
            case SDL_QUIT:
            done = true;
            break;
        case SDL_KEYDOWN:
            {
                if (event.key.keysym.sym == SDLK_ESCAPE)
                    done = true;
                break;
            }
        }
        for(int i = 0; i<playerCount; i++)
            player[i]->checkKeys(&event);
    }
    for(int i = 0; i<playerCount; i++)
        player[i]->step();
    for(int i = 0; i<EFFECT_MAX; i++)
        if (effects[i] != 0) effects[i]->step();
    ball->step();
    if (time<0)
    {
    	for (int i = 0; i<playerCount; i++)
    	{
    		if (ball->player==player[i])
    		{
    			points[i]+=20;
    		}
    	}
    	double maxp;
    	int maxi;
    	for (int i = 0; i<playerCount; i++)
    	{
    		if(points[i]>maxp)
    		{
    			maxi = i;
    			maxp = points[i];
    		}
    	}
    	_sprIB = SDL_LoadBMP("Data/Images/Game_IBT.bmp");
    	Font font(_sprIB, "Data/Fonts/vera.ttf", 12);
    	font.set_color(sdl_rgb(0,255,255));
    	font.set_halign(1);
    	font.set_valign(1);

    	string str = "";
    	if (maxi == 0)
    	{
    		str+=" Red ";
    	}
    	if (maxi == 1)
    	{
    		str+=" Green ";
    	}
    	if (maxi == 2)
    	{
    		str+=" Blue ";
    	}
    	if (maxi == 3)
    	{
    		str+=" Yellow ";
    	}
    	str+= " player wins";
    	draw();
    	font.draw_text(str.c_str(), 64, 16);
    	SDL_Flip(_sprIB);
    	infoBarDraw(_sprIB, 0.0, 0, 16, 4);
    	delete _sprIB;

    	glColor3ub(255, 255, 255);
    	SDL_GL_SwapBuffers();
    	Sleep(4000);
    	done = true;
    }
}

void Game::draw()
{
	glClearColor( 0.0f, 0.0f, 0.0f, 0.0f );
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glLoadIdentity();

	double camd = sqrt((camx - camtx)*(camx - camtx) + (camy - camty)*(camy - camty));
	double mczd = (atan2(camy - camty, -camx + camtx)*180/PI);

	if (abs(czd-mczd)>180)
		mczd+=360*sign(czd-mczd);
	if (camd>100) czd += (mczd-czd)*0.02;

	if (czd > 360) czd -= 360;
	if (czd < 0) czd += 360;

	cxd =  atan2(camz - camtz, camy - camty)*180/PI;
	cyd =  atan2(camz - camtz, -camx + camtx)*180/PI;
	cdd =  atan2(camz-camtz,camd)*180/PI;

	printf("cdd %f %f\n",cdd,czd);
	/*glRotatef(czd+90, 0, 0, 1);
	glRotatef(90-cdd, 1, 1, 0);
	glTranslatef(camx, -camy, -camz);*/

	glPushMatrix();

	glRotatef(cdd-90, 1, 0, 0);

	glPushMatrix();

	glRotatef(czd+90, 0, 0, 1);
	glTranslatef(-camx, -camy, -camz);
	camtx = 0; camty = 0;
	double minx = 100000; double maxx = -100000; double miny = 100000; double maxy = -100000;
	for(int i = 0;i<playerCount;i++)
	{
		if (player[i]->x < minx) minx = player[i]->x;
		if (player[i]->y < miny) miny = player[i]->y;
		if (player[i]->x > maxx) maxx = player[i]->x;
		if (player[i]->y > maxy) maxy = player[i]->y;
		camtx+=(player[i]->x)/double(playerCount);
		camty+=(player[i]->y)/double(playerCount);
	}
	//camtx = ball->x;
	//camty = ball->y;
	double midx = (minx+maxx)/2;
	double midy = (miny+maxy)/2;

	double idist = sqrt((midx-camtx)*(midx-camtx)
			           +(midy-camty)*(midy-camty));
	double idex = camtx - 200*(midx-camtx)/(idist+1);
	double idey = camty - 200*(midy-camty)/(idist+1);
	camz = 1.3*sqrt((maxx-minx)*(maxx-minx)+(maxy-miny)*(maxy-miny))+500;
	double iczd = atan2(camy - idey, -camx + idex)*180/PI;
	double icamd = sqrt((camx - idex)*(camx - idex) + (camy - idey)*(camy - idey));

	camhs = (0.2*icamd*cos(iczd*PI/180)+camhs)/2;
	camvs = (-0.2*icamd*sin(iczd*PI/180)+camvs)/2;

	if (camhs<0.2) camhs -= 0.1;
	if (-camhs<0.2) camhs += 0.1;
	if (abs(camhs)<0.2) camhs = 0;

	if (camvs<0.2) camvs -= 0.1;
	if (-camvs<0.2) camvs += 0.1;
	if (abs(camvs)<0.2) camvs = 0;

	camx += camhs;
	camy += camvs;

	//glTranslatef(0,0,-500);
	
	//printf("starts ground\n");

	GLuint texture = surf2tex(textureG);
	glBindTexture( GL_TEXTURE_2D, texture);
	glBegin(GL_QUADS);
	    glColor3f(0.3f, 0.3f, 0.3f);
		glTexCoord2i( 0, 0 );		glVertex3f(-1000,  -1000, 10);
		glTexCoord2i( 0, 1 );		glVertex3f(-1000,   1000, 10);
		glTexCoord2i( 1, 1 );		glVertex3f( 1000,   1000, 10);
		glTexCoord2i( 1, 0 );		glVertex3f( 1000,  -1000, 10);
	glEnd();

	glDeleteTextures( 1, &texture );

	glPushMatrix();
	for(int i = 0;i<EFFECT_MAX;i++)
	        if (effects[i] != 0) effects[i]->draw();
	glPopMatrix();

	texture = surf2tex(textureG);
	glBindTexture( GL_TEXTURE_2D, texture);

	glBegin(GL_QUADS);
		glColor3f(0.3f, 0.3f, 1.0f); glTexCoord2i( 0, 0 );
		glVertex3f( -1500, 1500, 30);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 0, 1 );
	  	glVertex3f( -1000, 1000, 10);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 1, 1);
	  	glVertex3f(  1000, 1000, 10);
	  	glColor3f(1.0f, 0.3f, 0.3f); glTexCoord2i( 1, 0 );
	  	glVertex3f(  1500, 1500, 30);

	  	glColor3f(0.3f, 1.0f, 0.3f); glTexCoord2i( 0, 1 );
	  	glVertex3f( -1500,-1500, 30);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 0, 0 );
	  	glVertex3f( -1000,-1000, 10);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 1, 0 );
	  	glVertex3f(  1000,-1000, 10);
	  	glColor3f(1.0f, 1.0f, 0.3f); glTexCoord2i( 1, 1 );
	  	glVertex3f(  1500,-1500, 30);

		glColor3f(1.0f, 1.0f, 0.3f); glTexCoord2i( 0, 0 );
		glVertex3f(  1500,-1500, 30);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 1, 0 );
	  	glVertex3f(  1000,-1000, 10);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 1, 1 );
	  	glVertex3f(  1000, 1000, 10);
	  	glColor3f(1.0f, 0.3f, 0.3f); glTexCoord2i( 0, 1 );
	  	glVertex3f(  1500, 1500, 30);

	  	glColor3f(0.3f, 1.0f, 0.3f); glTexCoord2i( 1, 0 );
	  	glVertex3f( -1500,-1500, 30);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 0, 0 );
	  	glVertex3f( -1000,-1000, 10);
	  	glColor3f(0.7f, 0.7f, 0.7f); glTexCoord2i( 0, 1 );
	  	glVertex3f( -1000, 1000, 10);
	  	glColor3f(0.3f, 0.3f, 1.0f); glTexCoord2i( 1, 1 );
	  	glVertex3f( -1500, 1500, 30);

	glEnd();

	glDeleteTextures( 1, &texture );
	//printf("ends ground\n");

	//drawWall();
	for(int i = 0; i<playerCount; i++)
        player[i]->draw();

	ball->draw();
    //printf("ends player\n");
    glPopMatrix();
    glPopMatrix();

    glColor3ub(255, 255, 255);
    /////////////////////////////////////////////////////////////////////////////////////////////
    printf("befor ibt\n");
    _sprIB = SDL_LoadBMP("Data/Images/Game_IBT.bmp");
    Font font(_sprIB, "Data/Fonts/vera.ttf", 23);
    font.set_color(sdl_rgb(0,255,255));
    font.set_halign(1);
    font.set_valign(1);
    int tt = round(float(time));
    string str = "Time: ";
    string str2;
    while (tt>0)
    {
		str2.push_back('0'+tt%10);
    	tt = tt/10;
    }
    for (unsigned int i = 0; i < str2.length() ;i++)
    {
//    	printf("%c",str2[str2.length()-i-1]);
    	str.push_back(str2[str2.length()-i-1]);
    }
//	printf("\n");
    font.draw_text(str.c_str(), 64, 16);
    SDL_Flip(_sprIB);
    infoBarDraw(_sprIB, 0.0, 3.9, 4, 1);
    delete _sprIB;
    //////////////////////////////
    if (ball->nach>0)
    {
    	_sprIB = SDL_LoadBMP("Data/Images/Game_IBT.bmp");
    	Font font(_sprIB, "Data/Fonts/vera.ttf", 16);
    	font.set_color(sdl_rgb(0,255,255));
    	font.set_halign(1);
    	font.set_valign(1);
    	int tt = ball->nach;
    	string str = "Ball limit: ";
    	string str2;
    	while (tt>0)
    	{
    		str2.push_back('0'+tt%10);
    		tt = tt/10;
    	}
    	for (unsigned int i = 0; i < str2.length() ;i++)
    	{
    		// 	printf("%c",str2[str2.length()-i-1]);
    		str.push_back(str2[str2.length()-i-1]);
    	}
    	//	printf("\n");
    	font.draw_text(str.c_str(), 64, 16);
    	SDL_Flip(_sprIB);
    	infoBarDraw(_sprIB, 0.0, -3.9, 4, 1);
    	delete _sprIB;
    }
    ///////////////////////////////
    double xx,yy;
    Font *fonts;

    for(int i = 0; i<playerCount; i++)
    {
    	_sprIB = SDL_LoadBMP("Data/Images/Game_IBT.bmp");
    	fonts = new Font(_sprIB, "Data/Fonts/vera.ttf", 20);
    	fonts->set_halign(1);
    	fonts->set_valign(1);

    	if (i == 0)
    	{
    		fonts->set_color(sdl_rgb(255,0,0));
    		xx = -4.7;
    		yy = 3;
    	}
    	if (i == 1)
    	{
    		fonts->set_color(sdl_rgb(0,255,0));
    		xx = -4.7;
    		yy = -3;
    	}
    	if (i == 2)
    	{
    		fonts->set_color(sdl_rgb(0,0,255));
    		xx = 4.7;
    		yy = 3;
    	}
    	if (i == 3)
    	{
    		fonts->set_color(sdl_rgb(255,255,0));
    		xx = 4.7;
    		yy = -3;
    	}
    	str.clear();
    	str2.clear();
    	tt = 10*round(float(points[i]));
    	if (tt == 0)
    	{
    		str2.push_back('0');
    	}
    	while (tt>0)
    	{
    		str2.push_back('0'+tt%10);
    		tt = tt/10;
		}
    	for (unsigned int i = 0; i < str2.length() ;i++)
    	{
    		str.push_back(str2[str2.length()-i-1]);
    	}
    	fonts->draw_text(str.c_str(), 64, 16);
    	SDL_Flip(_sprIB);
    	infoBarDraw(_sprIB, xx, yy, 4, 1);
    	delete fonts;
    	delete _sprIB;
    }
    printf("after ibt\n");

    /////////////////////////////////////////////////////////////////////////////////////////////

	glColor3ub(255, 255, 255);
	SDL_GL_SwapBuffers();
	printf("drawing succesful\n");
}

void Game::race_start()
{
    //WallC();
	time = 120;
	printf("race_start\n");
	for(int i = 0; i<playerCount; i++)
    {
		printf("   running %d\n",i);
		inh = i;
        player[i] = new Player(this);
        printf("   still still running %d\n",i);
        points[i] = 0;
    }
	ball = new Ball(this);
	printf("ball_created\n");
	_effE = 0;
	_effC = 0;
    for (int i = 0;i<EFFECT_MAX;i++)
    	effects[i] = 0;
}


void Game::add_effect(Effect *effect)
{
    if (_effC>=EFFECT_MAX)
       return;
    _effC++;
    while(effects[_effE] != 0) _effE = (_effE+1)%EFFECT_MAX;
    effects[_effE] = effect;
}

void Game::delete_effect(Effect *effect)
{
    if (effect == 0)
        return;
    for(int i = 0; i<EFFECT_MAX; i++)
    {
        if(effects[i] == effect)
        {
            delete effects[i];
            effects[i] = 0;
            _effC--;
            return;
        }
    }
}
/*void Game::WallC()
{
    _spWall = SDL_LoadBMP("Data/Images/wall20.bmp");

    _sww = 20;
    _swh = 20;

    _crWall.x = 0;
    _crWall.y = 0;
    _crWall.w = _sww;
    _crWall.h = _swh;

    loadLevel();
}

void Game::drawWall()
{
    for(int i = 0; i<wallCount; i++)
    {
        _drWall.x = allWall[i].x - allWall[i].w / 2;
        _drWall.y = allWall[i].y - allWall[i].h / 2;
        _drWall.w = allWall[i].w;
        _drWall.h = allWall[i].h;
        SDL_BlitSurface(_spWall, 0, _screen, &_drWall);
    }
}

void Game::loadLevel()
{
    FILE * File;
    File = fopen ("Data/Maps/Level3.txt" , "r");

    char ch;
    int n, up;
    while (getc(File) != '=')
        if (feof(File)) break;
    n = 0;
    ch = '0';
    while (ch != '=')
    {
        ch = getc(File);
        if ((ch >= '0') and(ch<='9'))
        {
            n = n*10 + ch - 48;
        }
        if (feof(File)) break;
    }
    _sww = n;
    _swh = n;
    while (getc(File) != '=')
        if (feof(File)) break;
    up = 0;
    ch = '0';
    while (ch != '=')
    {
        ch = getc(File);
        if ((ch >= '0') and(ch<='9'))
        {
            up = up*10 + ch - 48;
        }
        if (feof(File)) break;
    }
    for(int i = 0; i<540/_swh + up; i++)
    {
        while (getc(File) != '=')
            if (feof(File)) break;
        for(int j = 0; j<800/_sww; j++)
        {
            ch = getc(File);
            if (ch == '#')
            {
                allWall[wallCount] = Wall(this, j*_sww + _sww/2,
                                          (i - up)*_swh + _swh/2, _sww, _swh);
                allWall[wallCount-1].putToMap();
            }
        }
    }
    fclose (File);
}

void Game::drawShowers()
{
    SDL_Rect rect;
    for(int i = 0; i<playerCount; i++)
    {
        rect.x = i*200;
        rect.y = 520;
        SDL_BlitSurface(_imgGray, 0, _screen, &rect);
        rect.x = i*200 + 8;
        rect.y = 536+(100-(player[i]->health))*0.64;
        SDL_BlitSurface(_imgHB, 0, _screen, &rect);
        rect.x = i*200 + 34;
        rect.y = 536+(100-(player[i]->mpower))*0.64;
        SDL_BlitSurface(_imgMB, 0, _screen, &rect);
        rect.x = i*200;
        rect.y = 520;
        SDL_BlitSurface(_imgDown, 0, _screen, &rect);
    }
}

*/
