/*
 * Menu.cpp
 *
 *  Created on: 10.10.2009
 *      Author: Jan
 */

#include "libs.h"

Menu::Menu()
{
	printf("Menu - start\n");
	sdl_sound_init();
	sound = sdl_sound_play("Data/Music/menu.wav", 10000);
	printf("sound - start\n");
	playerCount = 2;

	_screen = SDL_CreateRGBSurface(SDL_GL_DOUBLEBUFFER, 1024, 1024, 24, 0x0000FF, 0x00FF00, 0xFF0000, 0);
    _caption = SDL_LoadBMP("Data/Images/Caption.bmp");
    //SDL_SetColorKey(_caption, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(_caption->format, 0, 0, 0));

    _background = SDL_LoadBMP("Data/Images/Menu_back.bmp");

    _cap_button[0] = SDL_LoadBMP("Data/Images/Menu_Play.bmp");
    _cap_button[1] = SDL_LoadBMP("Data/Images/Menu_Info.bmp");
    _cap_button[2] = SDL_LoadBMP("Data/Images/Menu_Options.bmp");
    _cap_button[3] = SDL_LoadBMP("Data/Images/Menu_Quit.bmp");
    for(int i=0; i<4; i++)
    {
        SDL_SetColorKey(_cap_button[i], SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(_cap_button[i]->format, 0, 0, 0));
    }

    _caprect.x = (_screen->w - _caption->w) / 2;
    _caprect.y = (_screen->h - _caption->h) / 2 - 230;

    _backrect.x = (_screen->w - _background->w) / 2;
    _backrect.y = (_screen->h - _background->h) / 2;

    int a,b,c;
    a = 0;
    b = 90;
    c = 150;
    _buttrect[0].x = (_screen->w - _cap_button[0]->w) / 2;
    _buttrect[0].y = (_screen->h - _cap_button[0]->h) / 2 - a;
    _buttrect[1].x = (_screen->w - _cap_button[1]->w) / 2 - c;
    _buttrect[1].y = (_screen->h - _cap_button[1]->h) / 2 - a + b;
    _buttrect[2].x = (_screen->w - _cap_button[2]->w) / 2 + c;
    _buttrect[2].y = (_screen->h - _cap_button[2]->h) / 2 - a + b;
    _buttrect[3].x = (_screen->w - _cap_button[3]->w) / 2;
    _buttrect[3].y = (_screen->h - _cap_button[3]->h) / 2 - a + b*2;

    // main loop
    _dQuit = false;
    while (!_dQuit)
    {
        step(_dQuit);
        draw();
    }
    // end main loop
    sdl_sound_stop(sound);

    // free loaded bitmap
    SDL_FreeSurface(_caption);
}

void Menu::step(bool &_dQuit)
{
    SDL_Event event;
    while (SDL_PollEvent(&event))
    {
        // check for messages
        switch (event.type)
        {
            case SDL_QUIT:
                _dQuit = true;
              break;

            case SDL_KEYDOWN:
            {
                // exit if ESCAPE is pressed
                if (event.key.keysym.sym == SDLK_ESCAPE)
                {
                    mGoto(3);
                }
                break;
            }
            case SDL_MOUSEBUTTONDOWN:
            {
                if (event.button.button == SDL_BUTTON_LEFT)
                {
                    if(mouse_in_B(this, 0)) mGoto(0);
                    if(mouse_in_B(this, 1)) mGoto(1);
                    if(mouse_in_B(this, 2)) mGoto(2);
                    if(mouse_in_B(this, 3)) mGoto(3);
                }
                break;
            }
        }
    }
}

void Menu::draw()
{
	SDL_FillRect(_screen, 0, SDL_MapRGB(_screen->format, 0, 0, 0));
	SDL_BlitSurface(_background, 0, _screen, &_backrect);
	SDL_BlitSurface(_caption, 0, _screen, &_caprect);
    SDL_BlitSurface(_cap_button[0], 0, _screen, &_buttrect[0]);
    SDL_BlitSurface(_cap_button[1], 0, _screen, &_buttrect[1]);
    SDL_BlitSurface(_cap_button[2], 0, _screen, &_buttrect[2]);
    SDL_BlitSurface(_cap_button[3], 0, _screen, &_buttrect[3]);
    SDL_Flip(_screen);
    menuDraw(_screen);
}

void Menu::mGoto(int to)
{
    switch (to) //0 - play; 1 - info; 2 - options; 3 - quit
    {
        case 0:
        {
            printf("running game\n");
        	sdl_sound_stop(sound);
        	_game = new Game(this);
        	printf("stopping game\n");
            delete _game;
            sound = sdl_sound_play("Data/Music/menu.wav", 10000);
            break;
        }
        case 1:
        {
            _info = new Info(_screen);
            delete _info;
            break;
        }
        case 2:
        {
        	_options = new Options(this);
            delete _options;
            break;
        }

        case 3:
        {
            _dQuit = true;
            break;
        }
    }


}
