/*
 * model.cpp
 *
 *  Created on: 19.10.2009
 *      Author: Jan
 */

#include "libs.h"

MFace::MFace(Mesh* mesh,int color,int a,int b,int c)
{
	x[0] = mesh->P[a].x;
	x[1] = mesh->P[b].x;
	x[2] = mesh->P[c].x;
	y[0] = mesh->P[a].y;
	y[1] = mesh->P[b].y;
	y[2] = mesh->P[c].y;
	z[0] = mesh->P[a].z;
	z[1] = mesh->P[b].z;
	z[2] = mesh->P[c].z;
	if (color == -1)
	{
		colr = 0; colg = 1; colb = 1;
		for(int i = 0;i<3;i++)
		{
			x[i]*=4;
			y[i]*=4;
			z[i]*=4;
		}
	}
	if (color == 0)
	{
		colr = 1; colg = 0; colb = 0;
	}
	if (color == 1)
	{
		colr = 0; colg = 1; colb = 0;
	}
	if (color == 2)
	{
		colr = 0; colg = 0; colb = 1;
	}
	if (color == 3)
	{
		colr = 1; colg = 1; colb = 0;
	}

}

void MFace::draw()
{
	int a = 40; double b = 60.0;
	glColor3f(((a+z[0])/b)*colr, ((a+z[0])/b)*colg, ((a+z[0])/b)*colb);
	glVertex3f(x[0],y[0],z[0]);
	//glColor3f(colr, colg, colb);
	glColor3f(((a+z[1])/b)*colr, ((a+z[1])/b)*colg, ((a+z[1])/b)*colb);
	glVertex3f(x[1],y[1],z[1]);
	//glColor3f(colr, colg, colb);
	glColor3f(((a+z[2])/b)*colr, ((a+z[2])/b)*colg, ((a+z[2])/b)*colb);
	glVertex3f(x[2],y[2],z[2]);
}

void Mesh::draw()
{
	//printf("draw mesh in\n");
	glBegin(GL_TRIANGLES);
	for(int i = 0;i<fn;i++)
	{
		F[i]->draw();
	}
	glEnd();
}

Model::Model()
{
}

Model::Model(int color, char* filename)
{
	//_player = player;
	int fminus = 1;
	printf("before reading\n");
	FILE* file;
	file = fopen(filename, "r");
	fscanf(file,"objects %d \n",&mn);
	printf("obj %i\n", mn);
	for (int oi = 0;oi<mn;oi++)
	{
		M.push_back(new Mesh());
		Mesh* acm = M[oi];
		fscanf(file,"vertices %d \n",&(acm->pn));
		printf("%i\n", (acm->pn));
		for(int i = 0;i<(acm->pn);i++)
		{
			acm->P.push_back(MPoint());
			fscanf(file,"v %f %f %f \n",
					&(acm->P[i].x),&(acm->P[i].y),&(acm->P[i].z));
			//printf("v %i\n", i);
		}
		fscanf(file,"faces %d \n",&(acm->fn));
		printf("%i\n", (acm->fn));
		int a,b,c;
		a = 0; b = 0; c = 0;
		for(int i = 0;i<(acm->fn);i++)
		{
			fscanf(file,"f %i %i %i \n",&a,&b,&c);
			acm->F.push_back(new MFace(acm,color, a-fminus,b-fminus,c-fminus));
		}
		fminus += acm->pn;
	}
	fclose(file);
	printf("after reading\n");
}

void Model::draw()
{
	//printf("draw model in\n");
	for(int i = 0;i<mn;i++)
	{
		M[i]->draw();
	}
}
