/*
 * options.cpp
 *
 *  Created on: 11.10.2009
 *      Author: Jan
 */

#include "libs.h"

Options::Options(Menu *menu)
{
    _screen = menu->_screen;
    _menu = menu;

    _spr_background = SDL_LoadBMP("Data/Images/Options_back.bmp");
    _spr_caption = SDL_LoadBMP("Data/Images/Options_cap.bmp");
    //SDL_SetColorKey(_spr_caption, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(_spr_caption->format, 0, 0, 0));
    _spr_window = SDL_LoadBMP("Data/Images/Options_win.bmp");
    SDL_SetColorKey(_spr_window, SDL_SRCCOLORKEY | SDL_RLEACCEL, SDL_MapRGB(_spr_window->format, 0, 0, 0));
    _spr_plus = SDL_LoadBMP("Data/Images/Options_plus.bmp");

    _caprect.x = (_screen->w - _spr_caption->w) / 2;
    _caprect.y = (_screen->h - _spr_caption->h) / 2-230;
    _backrect.x = (_screen->w - _spr_background->w) / 2;
    _backrect.y = (_screen->w - _spr_background->h) / 2;

    _phase = 1;
    _playerN = menu->playerCount;

    createOPD();

    bool done;
    while (!done)
    {
        step(done);
        draw();
    }
}

void Options::step(bool &done)
{
    SDL_Event event;
    while (SDL_PollEvent(&event))
    {
        // check for messages
        switch (event.type)
        {
            case SDL_QUIT:
                done = true;
            break;

            case SDL_KEYDOWN:
            {
                if (event.key.keysym.sym == SDLK_ESCAPE)
                    done = true;
                break;
            }
            case SDL_MOUSEBUTTONDOWN:
            {
                for (int i = 0; i<4; i++)
                {
                	if(_opd[i]->active)
                	{
						if(_opd[i]->_id < _playerN)
						{
							_playerN--;
						}
						else
						{
							_playerN++;
						}
                	}
                }
            	break;
            }
        }
    }
    for(int i = 0; i<4; i++)
        _opd[i]->step();

    _menu->playerCount = _playerN;
}

void Options::draw()
{
    SDL_FillRect(_screen, 0, SDL_MapRGB(_screen->format, 0, 0, 0));

    SDL_BlitSurface(_spr_background, 0, _screen, &_backrect);
    SDL_BlitSurface(_spr_caption, 0, _screen, &_caprect);

    if (_phase == 1)
    {

        for(int i = 0;i<4;i++)
            _opd[i]->draw();

        //Font font(_screen, "Data/Fonts/comic.ttf", 100);
        //Font font2(_screen, "Data/Fonts/comic.ttf", 32);
        //font.set_color(sdl_rgb(255,250,60));
        //font2.set_color(sdl_rgb(100,250,60));
        //font2.draw_text("xy", 400, 150);
        //font2.draw_text("xy", 400, 190);
    }
    SDL_Flip(_screen);
    menuDraw(_screen);
}

void Options::createOPD()
{
    for(int i = 0;i<4;i++)
    {
        _opd[i] = new OPD(this, i);
    }
}

OPD::OPD(Options* options, int id)
{
    _options = options;
    _screen = _options->_screen;
    _id = id;
    active = 0;

    if ((_id == 0)||(_id == 2)) _winrect.x = 129;
    if ((_id == 1)||(_id == 3)) _winrect.x = 512;
    if ((_id == 0)||(_id == 1)) _winrect.y = 378;
    if ((_id == 2)||(_id == 3)) _winrect.y = 585;

    _plusrect.x = _winrect.x + (_options->_spr_window->w - _options->_spr_plus->w/2) / 2;
    _plusrect.y = _winrect.y + (_options->_spr_window->h/2 - _options->_spr_plus->h) / 2;

}

void OPD::step()
{
    enabled = _id<_options->_playerN;
    active = 0;
    if (enabled)
    {
        if (mouse_in_rect(_winrect.x+349, _winrect.y+10, _winrect.x+375, _winrect.y+36))
            active = 1;
    }
    if (_id == _options->_playerN)
    {//104 3 42
    	if (mouse_in_rect(_plusrect.x+3, _plusrect.y+42, _plusrect.x+97, _plusrect.y+62)
    			||mouse_in_rect(_plusrect.x+42, _plusrect.y+3, _plusrect.x+62, _plusrect.y+97))
    		active = 1;
    }

}

void OPD::draw()
{
    if (enabled)
    {
        _cutrect.w = _options->_spr_window->w;
        _cutrect.h = _options->_spr_window->h/2;
        _cutrect.x = 0;
        _cutrect.y = 0;
        if(active)
            _cutrect.y = _options->_spr_window->h/2 - 2;
        SDL_BlitSurface(_options->_spr_window, &_cutrect, _screen, &_winrect);
        Font font(_screen, "Data/Fonts/vera.ttf", 32);
        Font font2(_screen, "Data/Fonts/cour.ttf", 20);
        font.set_color(sdl_rgb(0,250,250));
        font2.set_color(sdl_rgb(0,220,220));
        int x1 = 100; int x2 = 80;
        if (_id == 0)
        {
            font.draw_text("Player 1:", _winrect.x+x1, _winrect.y+40);
            font2.draw_text("   up: key_up", _winrect.x+x2, _winrect.y+80);
            font2.draw_text(" down: key_down", _winrect.x+x2, _winrect.y+100);
            font2.draw_text(" left: key_left", _winrect.x+x2, _winrect.y+120);
            font2.draw_text("right: key_right", _winrect.x+x2, _winrect.y+140);
        }
        if (_id == 1)
		{
        	font.draw_text("Player 2:", _winrect.x+x1, _winrect.y+40);
        	font2.draw_text("   up: key_W", _winrect.x+x2, _winrect.y+80);
        	font2.draw_text(" down: key_S", _winrect.x+x2, _winrect.y+100);
        	font2.draw_text(" left: key_A", _winrect.x+x2, _winrect.y+120);
        	font2.draw_text("right: key_D", _winrect.x+x2, _winrect.y+140);
		}
        if (_id == 2)
        {
        	font.draw_text("Player 3:", _winrect.x+x1, _winrect.y+40);
        	font2.draw_text("   up: key_U", _winrect.x+x2, _winrect.y+80);
        	font2.draw_text(" down: key_J", _winrect.x+x2, _winrect.y+100);
        	font2.draw_text(" left: key_H", _winrect.x+x2, _winrect.y+120);
        	font2.draw_text("right: key_K", _winrect.x+x2, _winrect.y+140);
        }
        if (_id == 3)
        {
        	font.draw_text("Player 4:", _winrect.x+x1, _winrect.y+40);
        	font2.draw_text("   up: key_8", _winrect.x+x2, _winrect.y+80);
        	font2.draw_text(" down: key_5", _winrect.x+x2, _winrect.y+100);
        	font2.draw_text(" left: key_4", _winrect.x+x2, _winrect.y+120);
        	font2.draw_text("right: key_6", _winrect.x+x2, _winrect.y+140);
        }
    }
    if (_id == _options->_playerN)
    {
        _cutrect.w = _options->_spr_plus->w/2;
        _cutrect.h = _options->_spr_plus->h;
        _cutrect.x = 0;
        _cutrect.y = 0;
        if(active)
            _cutrect.x = _options->_spr_plus->w/2;
        //if (active)
        //{
        //}
        SDL_BlitSurface(_options->_spr_plus, &_cutrect, _screen, &_plusrect);
    }
}


