#include "libs.h"

#ifndef PI
#define PI 3.141592653589793238
#endif

Player::Player(Game* game)
{
    printf("player created\n");
	_game = game;
    //_screen = _game->_screen;
    color = _game->inh;
    indrift = 0;
    todrift = 0;

    model = new Model(color,"./Data/Models/modelf");

    length = 5;
    width = 3;
    height = 2;

    if (color == 0)
    {
    	KEY_UP = SDLK_UP;
    	KEY_DOWN = SDLK_DOWN;
    	KEY_LEFT = SDLK_LEFT;
    	KEY_RIGHT = SDLK_RIGHT;
    	KEY_SHOT = SDLK_m;
    }
    if (color == 1)
    {
       	KEY_UP = SDLK_w;
       	KEY_DOWN = SDLK_s;
       	KEY_LEFT = SDLK_a;
       	KEY_RIGHT = SDLK_d;
       	KEY_SHOT = SDLK_f;
    }
    if (color == 2)
	{
    	KEY_UP = SDLK_u;
    	KEY_DOWN = SDLK_j;
    	KEY_LEFT = SDLK_h;
    	KEY_RIGHT = SDLK_k;
    	KEY_SHOT = SDLK_l;
    }
    if (color == 3)
    {
       	KEY_UP = SDLK_KP8;
       	KEY_DOWN = SDLK_KP5;
       	KEY_LEFT = SDLK_KP4;
       	KEY_RIGHT = SDLK_KP6;
       	KEY_SHOT = SDLK_KP0;
    }

    create();
}

void Player::create()
{
    for (int i = 0; i<5; i++)
        check[i] = false;

    x = y = z = 0;
    fsp = ssp = speed = 0;
    dir = xdir = ydir = zdir = 0;
    for(int i = 0;i<4;i++)
    {
    	whx[i] = 0; why[i] = 0;
    	pwhx[i] = 0; pwhy[i] = 0;
    }
    if (color == 0)
    {
    	x = 800;
    	y = 800;
    	zdir = 45;
    }
    if (color == 2)
    {
       	x = -800;
       	y = 800;
       	zdir = 135;
    }
    if (color == 1)
    {
    	x = -800;
    	y = -800;
    	zdir = 225;
	}
    if (color == 3)
    {
    	x = 800;
    	y = -800;
    	zdir = 315;
    }

    acdp = 0;
}

Player::~Player()
{
	delete model;
}

void Player::step()
{
	acdp = 0;
	if (_isnan(x))
	{
		create();
	}
	double px = x;
	double py = y;
	double pzdir = zdir;

	if (check[0])
		go(0.8);
	if (check[1])
		go(-0.6);
	if (check[2])
		rot(1);
	if (check[3])
		rot(-1);

	move();
	int whvzd1 = 30;
	int whvzd2 = 37;
	int whang1 = 40;
	int whang2 = 25;
	for(int i = 0;i<4;i++)
	{
	   	pwhx[i] = whx[i]; pwhy[i] = why[i];
	}
	whx[0] = x+whvzd1*cos((zdir+whang1)*PI/180);
	why[0] = y+whvzd1*sin((zdir+whang1)*PI/180);
	whx[1] = x+whvzd1*cos((zdir-whang1)*PI/180);
	why[1] = y+whvzd1*sin((zdir-whang1)*PI/180);
	whx[2] = x+whvzd2*cos((zdir+180-whang2)*PI/180);
	why[2] = y+whvzd2*sin((zdir+180-whang2)*PI/180);
	whx[3] = x+whvzd2*cos((zdir+180+whang2)*PI/180);
	why[3] = y+whvzd2*sin((zdir+180+whang2)*PI/180);

	if (indrift)
	{
		for(int i = 0;i<4;i++)
		{
			new Ef_flek(_game, round(float( whx[i])), round(float( why[i])),
							   round(float(pwhx[i])), round(float(pwhy[i])) );
		}
	}

	int cw = collWalls();
	if (cw>0)
	{
		printf("collision %f, %f, %f, %f, %f \n", px, py, speed, dir, zdir);
		x = px;
		y = py;
		zdir = pzdir;
		speed = speed*0.4;
		if (cw == 2)
		{dir = 180 - dir;}
		if (cw == 3)
		{dir = 360 - dir;}
		printf("collision %f, %f, %f, %f, %f \n", px, py, speed, dir, zdir);
	}
	printf("position %f, %f, %f \n", x, y, speed);
}

void Player::move()
{
	double dragforce = 0.001;
	//if (color == 0) printf("ssp %f \n",ssp);
	//printf("zd %f \n",zdir-dir);
	fsp = speed*cos((zdir-dir)*PI/180);
	ssp = speed*sin((zdir-dir)*PI/180);
	todrift -=2;
	todrift +=ssp*ssp/5.0;
	todrift *=0.93;
	if (todrift+acdp > 33) indrift = 1;
	if (todrift+acdp/2.0 < 6) indrift = 0;
	if (indrift)
	{
		dragforce = 0.1;
		todrift -=3;
		fsp*=0.97;
		ssp*=0.97;
	}
	else
	{
		fsp*=0.996;
		ssp*=0.5;
	}
	dir = -atan2(ssp,fsp)*180/PI+zdir;
	speed = sqrt(fsp*fsp+ssp*ssp);
	speed*=0.999;
	if (abs(speed)<dragforce)
	{
		speed = 0;
		dir = zdir;
	}
	else
	{
		if (speed>0)
			speed-=dragforce;
		if (speed<0)
			speed+=dragforce;
	}
	x+=speed*cos(dir*PI/180);
	y+=speed*sin(dir*PI/180);
}

void Player::go(double force)
{
	if (indrift) force*=0.8;
	fsp = speed*cos((zdir-dir)*PI/180);
	ssp = speed*sin((zdir-dir)*PI/180);
	fsp+=force;
	if ((force<0)&&(fsp>0))
	{
		fsp*=0.95;
		acdp+=2;
	}
	dir = -atan2(ssp,fsp)*180/PI+zdir;
	speed = sqrt(fsp*fsp+ssp*ssp);
	acdp +=3;

}

void Player::rot(double angle)
{
	if (indrift) angle*=0.8;
	zdir+=sqrt(speed)*angle;
	dir+=sqrt(speed)*angle/10;
}

void Player::draw()
{
	//printf("draw player\n");
	glPushMatrix();
		glTranslatef(x, y, z+20);
		glEnable( GL_DEPTH_TEST );
		glPushMatrix();
			glRotated(zdir+90, 0, 0, 1);
			//glRotated(ydir, 0, 1, 0);
			//glRotated(xdir, 1, 0, 0);
			//printf("draw model bef\n");
			model->draw();
		glPopMatrix();
		glDisable( GL_DEPTH_TEST );
	glPopMatrix();
}

int Player::collWalls()
{
	if (x<_game->wminx) return 2;
	if (y<_game->wminy) return 3;
	if (x>_game->wmaxx) return 2;
	if (y>_game->wmaxy) return 3;
	for(int i = 0;i<4;i++)
	{
		if (whx[i]<_game->wminx) return 2;
		if (why[i]<_game->wminy) return 3;
		if (whx[i]>_game->wmaxx) return 2;
		if (why[i]>_game->wmaxy) return 3;
	}
	return 0;
/*    for (int i = 1; i<_game->wallCount; i++)
    {
        Rectangle r1 = Rectangle(dx - cw, dy - ch, dx + cw, dy + ch);
        Wall w = _game->allWall[i];
        Rectangle r2 = Rectangle(w.x - w.w / 2, w.y - w.h / 2,
                                 w.x + w.w / 2, w.y + w.h / 2);
        if (c_rect_rect(r1, r2)) return true;
    }
    return false;*/
}

void Player::collWeapon()
{

}

void Player::checkKeys(SDL_Event* event)
{
    switch (event->type)
    {
        case SDL_KEYDOWN:
        {
            if (event->key.keysym.sym == KEY_LEFT)
                check[2] = true;
            if (event->key.keysym.sym == KEY_RIGHT)
                check[3] = true;
            if (event->key.keysym.sym == KEY_UP)
                check[0] = true;
            if (event->key.keysym.sym == KEY_DOWN)
                check[1] = true;
            if (event->key.keysym.sym == KEY_SHOT)
                check[4] = true;
            break;
        }

        case SDL_KEYUP:
        {
            if (event->key.keysym.sym == KEY_LEFT)
                check[2] = false;
            if (event->key.keysym.sym == KEY_RIGHT)
                check[3] = false;
            if (event->key.keysym.sym == KEY_UP)
                check[0] = false;
            if (event->key.keysym.sym == KEY_DOWN)
            	check[1] = false;
            if (event->key.keysym.sym == KEY_SHOT)
            	check[4] = false;
            break;
        }
    }
}
