#ifndef PLAYERS_H_
#define PLAYERS_H_

#include "libs.h"

#define MAX_MAGIC 64
#define STORE_SIZE 3

#define KEY_UP keys[0]
#define KEY_DOWN keys[1]
#define KEY_LEFT keys[2]
#define KEY_RIGHT keys[3]
#define KEY_SHOT keys[4]

struct RoadParam
{
	double dragf;
	double friction;
	double xfric, yfric;
	double accel;
};

class Player
{
    Game* _game;
    SDL_Surface* _screen;
    Model *model;
    bool check[5];
    int keys[5];
    double whx[4],why[4];
    double pwhx[4],pwhy[4];
    double acdp;
public:
    int color;
    double x,y,z;
    double dir,speed;
    double fsp, ssp;
    double xdir,ydir,zdir;
    double length,width,height;
    bool indrift;
    double todrift;
    RoadParam roadparam;
    
    Player(Game* game);
    ~Player();
    void create();
    void step();
    void move();
    void go(double force);
    void rot(double angle);
    void draw();
    void checkKeys(SDL_Event* event);
    
    int collWalls();
    void collWeapon();
};



#endif /*PLAYERS_H_*/
