/*
 * sound.cpp
 *
 *  Created on: 24.10.2009
 *      Author: Jan
 */

#include "libs.h"

void sdl_sound_init()
{
	int audio_rate = 22050;			//Frequency of audio playback
	Uint16 audio_format = AUDIO_S16SYS; 	//Format of the audio we're playing
	int audio_channels = 2;			//2 channels = stereo
	int audio_buffers = 4096;		//Size of the audio buffers in memory

	if(Mix_OpenAudio(audio_rate, audio_format, audio_channels, audio_buffers) != 0) {
		printf("Unable to initialize audio: %s\n", Mix_GetError());
		exit(1);
	}
}
Mix_Chunk* sdl_sound_play(char *file, int loop)
{
	Mix_Chunk *sound = NULL;
	int channel;

	sound = Mix_LoadWAV(file);
	if(sound == NULL) {
		printf("Unable to load WAV file: %s\n", Mix_GetError());
	}

	//Play our sound file, and capture the channel on which it is played
	channel = Mix_PlayChannel(-1, sound, loop);
	if(channel == -1) {
		printf("Unable to play WAV file: %s\n", Mix_GetError());
	}

	return sound;
}

void sdl_sound_stop(Mix_Chunk *sound)
{
	Mix_FreeChunk(sound);
	//Mix_CloseAudio();
}


